/**
 * Within the scope of Darlean, a *struct* is an object that can be converted from and to
 * a [[IContainer | container]], and that can contain [[IAttachment | attachments]]) that
 * can be binary, text or structs themselves (that then can again contain attachments, et
 * cetera).
 *
 * Structs play an important role within Darlean, because they provide a simple and very efficient way
 * for user code to interact with the [[containers]] that are used to transfer action requests and
 * responses over the network.
 *
 * A regular object (like `{Hello: 'World'}`) can be turned into a struct by passing it to the
 * [[struct]] function. The object that is converted into a struct then implements [[IStruct]] because
 * the properties [[__struct]], [[_att]] and [[_cont]] that make up [[IStruct]] are injected to the
 * object by the [[struct]] function.
 *
 * Example: creating a struct from an object
 * ```
 * const s = struct({
 *   hello: 'World'
 * });
 * console.log(s.hello);
 * // Prints: World
 * console.log(s);
 * // Prints: { hello: 'World', _cont: [Function], __struct: [Function], _att: [Function] }
 * ```
 *
 * Example: Working with structs
 *```
 * interface IAbc {a: number, b: number, c: IBinaryAttachmentRef};
 * function sum(input: Struct<IAbc>) {
 *   return input.a + input.b + input._att(input.c).length;
 * }
 * const s = struct<IAbc>( (attach) => ({
 *   a: 3,
 *   b: 4,
 *   c: attach( Buffer.from('Hello'))
 * }));
 * console.log( sum(s) );  // Prints 12
 * ```
 *  Darlean provides functionality for:
 *  * Creating structs from objects (the [[struct]] function)
 *  * Creating structs with attachments ([[struct]] together with an [[Attacher]] function)
 *  * Extracting an attachment from a struct ([[IStruct._att]])
 *  * Extracting [[IAttachment.binary|binary]], [[IAttachment.text|text]] or [[IAttachment.struct|struct]]
 *    data from [[IAttachment|attachments]]
 *  * Retrieving the underlying container of a struct ([[IStruct._cont]])
 *  * Retrieving the underlying container of an attachment ([[IAttachment._cont]])
 *
 * @module structs
 **/

import {
  AnObject,
  ContainerData,
  IContainer,
  IContainerizeable1,
  IContainer0,
  ContainerLike1,
  ContainerLike0,
  asContainer,
  IContainer1,
  container,
  IContainerizeable0,
} from '.';

export type AttachmentType = 'binary' | 'text' | 'struct' | 'empty';
export type AttachmentData = Buffer | string | AnObject | undefined;

/**
 * Represents a reference to an attachment. Instances can be generated by means of the [[struct]] function.
 */
export interface IAttachmentRef {
  /**
   * The index of the child within the struct's container that contains the attachment information.
   * This field is prefixed with double underscores, so it should not be used directly.
   */
  __child_idx: number;
}

/**
 * Reference to a binary attachment. Useful to 'annotate' that certain struct fields expect a binary attachment.
 */
export type IBinaryAttachmentRef = IAttachmentRef;
/**
 * Reference to a text attachment. Useful to 'annotate' that certain struct fields expect a text attachment.
 */
export type ITextAttachmentRef = IAttachmentRef;
/**
 * Reference to a structured attachment of type T. Useful to 'annotate' that certain struct fields expect a
 * structured attachment.
 */
// eslint-disable-next-line @typescript-eslint/no-unused-vars
export type IStructAttachmentRef<T> = IAttachmentRef;

/**
 * Type alias to indicate that a value is both a struct object itself as well as an IStruct. A
 * Struct can be created by means of the [[struct]] function.
 *
 * Example:
 * ```
 * interface Abc {a: number, b: number, c: IBinaryAttachmentRef};
 * function sum(input: Struct<Abc>) {
 *   return input.a + input.b + input._att(input.c).length;
 * }
 * const s = struct<Abc>( (attach) => ({
 *   a: 3,
 *   b: 4,
 *   c: attach( Buffer.from('Hello'))
 * }));
 * console.log( sum(s) );  // Prints 12
 * ```
 */
export type Struct<T extends AnObject> = T & IStruct<T>;

export type StructLike<T extends AnObject> = T | Struct<T>;

/**
 * Within the scope of Darlean, a *struct* is an object that can be converted from and to
 * a [[IContainer | container]], and that can contain [[IAttachment | attachments]]) that
 * can be binary, text or structs themselves (that then can again contain attachments, et
 * cetera).
 *
 * An object can be turned into a struct by calling the [[struct]] function. An object that has become
 * a struct, implements [[IStruct]], which means that the properties [[__struct]], [[_att]] and [[_cont]]
 * are added to the object.
 **/
export interface IStruct<T extends AnObject> extends IContainerizeable1<T> {
  /**
   * Indicator that this object is a struct. Used internally by [[isStruct]]. This field is
   * implemented as a function so that it will not be included in generated json (function are ignored
   * when generating json via JSON.stringify).
   *
   * This field is prefixed with a double underscore because it is for internal use only.
   **/
  __struct: () => boolean;

  /**
   * Function that returns a sub-attachment for this struct object. It receives an [[IAttachmentRef]] that
   * can be obtained by invoking [[struct]] with an [[Attacher]] function is parameter.
   *
   * This field is prefixed with one underscore to make reduce the likelyhood of interfering with the
   * regular fields of the struct object.
   **/
  _att<A>(ref: IAttachmentRef): IAttachment<A>;

  /**
   * Function that returns a the underlying container that stores the struct object and any attachments.
   *
   * This field is prefixed with one underscore to make reduce the likelyhood of interfering with the
   * regular fields of the struct object.
   */
  _cont(): IContainer<T, ContainerData>;
}

/**
 * Represents an attachment to a struct. Attachments can be binary, text, structured or empty. Struct attachments
 * can have sub-attachments themselves, thus forming a tree-like hierarchy of attachments.
 *
 * Attachments are [[IContainerizeable]], which means that their underlying container can be obtained by means
 * of the [[_cont]] methods, and that they can be passed to functions that accept an [[IContainerizeable]], like
 * the [[asContainer]] function.
 *
 * Attachment instances can be created by means of [[IStruct._att]].
 */
export interface IAttachment<StructType> extends IContainerizeable0 {
  /**
   * Function that indicates that an object that implements this interface is an IAttachment.
   *
   * This indicator is modeled as a function so that it will not be included in generated JSON (functions are
   * ignored by JSON.stringify).
   */
  __attachment: () => boolean;

  /**
   * Returns the underlying container that holds this attachments data.
   */
  _cont(): IContainer0;

  /**
   * Returns the type of this attachment.
   */
  getType(): AttachmentType;

  /**
   * Returns the contents of this attachment as a Buffer. Throws an exception when the attachment
   * is not a binary attachment.
   */
  binary(): Buffer;

  /**
   * Returns the contents of this attachment as a string. Throws an exception when the attachment
   * is not a text attachment.
   */
  text(): string;

  /**
   * Returns the contents of this attachment as an object. Throws an exception when the attachment
   * is not a struct attachment.
   */
  struct(): Struct<StructType>;

  /**
   * Returns the contents of this attachment as either a Buffer, a string, an object or undefined.
   */
  raw(): ContainerData;
}

/**
 * Alias for a struct attachment with unknown struct type, or for a non-struct attachment (for which
 * a struct type is not applicable).
 */
export type IAttachment0 = IAttachment<unknown>;

/**
 * Alias for types that can be converted into attachments. That are objects that implement [[IAttachment]],
 * plain objects (that do not implement [[IAttachment]], strings, Buffers, the value undefined, and IContainers
 * that hold objects).
 */
export type AttachmentLike<StructType extends AnObject> =
  | IAttachment<StructType>
  | AttachmentData
  | IContainer1<StructType>;
export type AttachmentLike0 = AttachmentLike<AnObject>;

/**
 * Internal class that represents an attachment that is backed by an [[IContainer]] instance. Should not be
 * used directly.
 * @internal
 */
export class ContainerAttachment<StructType extends AnObject> implements IAttachment<StructType> {
  protected container: IContainer0;
  protected structValue?: Struct<StructType>;
  public __attachment: () => boolean = () => true;

  constructor(container: IContainer<ContainerData, ContainerData>) {
    this.container = container;
  }

  public getType(): AttachmentType {
    return this.container.getKind() as AttachmentType;
  }

  public binary(): Buffer {
    return this.container.getDataBinary();
  }

  public text(): string {
    return this.container.getDataText();
  }

  public struct(): Struct<StructType> {
    if (!this.structValue) {
      const value = (this.container.getDataStruct() as StructType) ?? {};
      (value as unknown as IStruct<AnObject>).__struct = () => true;
      (value as unknown as IStruct<AnObject>)._att = (ref) => this.getAttachment(ref);
      (value as unknown as IStruct<AnObject>)._cont = () => this.container as IContainer<AnObject, ContainerData>;
      this.structValue = value as unknown as Struct<StructType>;
    }
    return this.structValue;
  }

  public raw(): ContainerData {
    return this.container.getData();
  }

  public _cont(): IContainer0 {
    return this.container;
  }

  public getAttachment<A>(ref: IAttachmentRef): IAttachment<A> {
    const c = this.container.getChild<ContainerData>(ref.__child_idx);
    return new ContainerAttachment(c);
  }
}

/**
 * Function signature that can be used to add [[IAttachmentRef | attachment references|]] to a struct.
 * See also the overloaded version of the [[struct]] function that accepts an Attacher as argument.
 *
 * ```
 * const myStruct = struct( (attach) => ({
 *   myBuffer: attach(Buffer.from('Hello'))
 * }));
 * ```
 */
export type Attacher<T extends AnObject> = (attach: (att: AttachmentLike<T>) => IAttachmentRef) => T;

/**
 * Converts an attachment, containerizeable, struct, buffer, string, object or undefined into an attachment.
 * When the provided value already is an attachment, it is simply returned. When a container can be derived
 * because value is an instance of [[IContainer]] or [[IContainerizeable]], the returned attachment will
 * use this exact same container. Otherwise, a new container is generated, and an attachment around that
 * container is returned.
 **/
export function asAttachment<T>(value: AttachmentLike<T>): IAttachment<T> {
  if (isAttachment(value)) {
    return value as IAttachment<T>;
  }
  if (isStruct(value)) {
    const c = (value as IStruct<T>)._cont();
    return new ContainerAttachment(c);
  }
  const c = asContainer(value);
  return new ContainerAttachment(c);
}

/**
 * Returns whether value is an attachment.
 */
export function isAttachment(value: AttachmentLike0): boolean {
  return (value as IAttachment0)?.__attachment !== undefined;
}

/**
 * Returns whether value is a struct.
 */
export function isStruct(value: unknown): boolean {
  return (value as IStruct<AnObject>)?.__struct !== undefined;
}

/**
 * Converts the provided object vakue into a struct by injecting the [[IStruct._cont|_cont]], [[IStruct._att|_att]]
 * and [[IStruct.__struct|__struct]] methods, thus effectively making it implement [[IStruct]].
 * When value already is a struct, it is simply returned. Otherwise, the provided object is converted into a struct that
 * is backed by a newly generated container.
 *
 * ```
 * const s = struct({
 *   hello: 'World'
 * });
 * console.log(s.hello);   // Prints: World
 * console.log(s);         // Prints: { hello: 'World', _cont: [Function], __struct: [Function], _att: [Function] }
 * ```
 *
 * @param value The object or struct to be converted to a struct
 * @returns value (unmodified) if value already is a struct, or value augmented with the
 * fields of [[IStruct]] when value is not already a struct.
 */
export function struct<T extends AnObject>(value: T | ContainerLike1<T>): Struct<T>;

/**
 * Creates a struct that contains attachments.
 *
 * Typical use:
 * ```
 * const myStruct = struct( (attach) => ({
 *   myBuffer: attach(Buffer.from('Hello'))
 * }));
 * ```
 * @param attacher The attacher function (usually an arrow function) that returns an
 * object that is then converted into a struct. Within the attacher function, the provided
 * 'attach' function can be used to generate [[IAttachmentRef]] instances.
 */
export function struct<T extends AnObject>(attacher: Attacher<T>): Struct<T>;

export function struct<T extends AnObject>(options: T | ContainerLike1<T> | Attacher<T>): T & IStruct<T> {
  if (typeof options === 'function') {
    const attachments: ContainerLike0[] = [];
    const opts = options((att) => {
      attachments.push(asContainer(att));
      return {
        __child_idx: attachments.length - 1,
      };
    });
    const c = container(opts, attachments);
    const att = asAttachment<T>(c);
    return att.struct();
  } else if (isStruct(options)) {
    return options as T & IStruct<T>;
  } else {
    const att = asAttachment<T>(options);
    return att.struct();
  }
}
